%%Disclosures to Business Associates

permitted_by_164_502_e(A):-
  permitted_by_164_502_e_1_i(A);
  excluded_164_502_e_1_ii(A).
  %\+ excluded_164_502_e_1_ii(A).

%See if the message is allowed to be received by any of the covered entities of 
%this business associate or if the covered entity is disclosing protected health.
%to a business associate.
permitted_by_164_502_e_1_i(A) :-
  is_phi(A),
  ( (is_from_coveredEntity(A),
     is_to_businessAssociateOf(A));
    (is_to_coveredEntity(A),
     is_from_businessAssociateOf(A))
  ),
  (is_for_createProtectedHealthInfo(A);
   is_for_receiveProtectedHealthInfo(A)).
  %is_belief_lawfulBusinessAssociate(A, Y).

excluded_164_502_e_1_ii(A):-
  excluded_164_502_e_1_ii_a(A);
  excluded_164_502_e_1_ii_b(A);
  excluded_164_502_e_1_ii_c(A).
  
excluded_164_502_e_1_ii_a(A) :-
  is_about_individual(A),
  is_to_healthCareProvider(A),
  is_for_treatment(A),
  is_from_coveredEntity(A).
  
excluded_164_502_e_1_ii_b(A) :-
  (is_from_healthInsuranceIssuer(A);
   is_from_groupHealthPlan(A)),
  permitted_by_165_504_f(A).
  
%enrollment information is collected by the government agency.  
excluded_164_502_e_1_ii_c(A) :- 
  is_from_governmentAgencyHealthPlan(A).
  
