%%Example system
:- ['HIPAA.pl'].
inRole(b, healthCare_clearing_house).
inRole(c, healthCare_provider).
inRole(d, health_oversight_agency).
inRole(e, public_health_authority).
inRole(f, healthCare_accreditation_organization).
inRole(g, healthcare_provider).
inRole(h, health_plan).
inRole(i, health_insurance_issuer).
inRole(j, group_health_plan).
inRole(k, government_agency_health_plan).
inRole(l, healthCare_plan).
	
inRole(m, covered_entity).
inRole(n, covered_entity).

inRole(o, entity).

%inRole(doctor, covered_entity).
inRole(doctor, healthCare_provider).
inRole(doctor, adult).
%inRole(nurse, covered_entity).
inRole(nurse, healthCare_provider).
inRole(nurse, adult).

inRole(assistant, secretary).
inRole(assistant, adult).
inRole(lawyer, legal_attorney).
inRole(lawyer, adult).

inRole(patient, individual).
inRole(patient, adult).
inRole(cop, law_enforcement_officer).
inRole(cop, individual).
inRole(cop, adult).
inRole(thief, suspected_crime_perpetrator).
inRole(thief, individual).
inRole(thief, adult).
inRole(teen, emancipated_minor).
inRole(teen, individual).
inRole(kid, unemancipated_minor).
inRole(kid, individual).
inRole(mom, individual).
inRole(mom, adult).
inRole(dad, individual).
inRole(dad, adult).
inRole(dead, deceased_individual).
inRole(dead, individual).
inRole(dead, adult).


%meaningless right now.
employee_of(doctor, m).
employee_of(nurse, m).
employee_of(assistant, m).
employee_of(lawyer, m).

%Purposes of specifics.
purpose( surgery, treatment).
%minimum necessary or less.
minimum( phi, payment).

%business_assocate(X,Y):  Y is a business associate of X.
business_associate(o, m).

in_relation(teen, n).

personal_representative(dead, patient).
personal_representative(thief, teen).
parent(kid, mom).
parent(kid,doctor).
personal_representative(teen, dad).
personal_representative(doctor, thief).
loco_parentis(kid, lawyer).

test :-
  pbh(a(mom,nurse,kid,phi,treatment,null,null)).
test :-
  pbh(a(lawyer,nurse,kid,phi,treatment,null,null)).
test :-
  pbh(a(teen,nurse,thief,phi,treatment,null,null)).
test :-
  pbh(a(patient,nurse,dead,phi,treatment,null,null)).
test :-
  pbh(a(dad,nurse,teen,phi,treatment,null,null)).
test :-
  pbh(a(thief,nurse,doctor,phi,treatment,null,null)).
test :-
  pbh(a(o,m,dad,phi,create_protected_health_info,null,null)).
test :-
  pbh(a(m,o,dad,phi,create_protected_health_info,null,null)).
test :-
  pbh(a(m,o,dad,phi,create_protected_health_info,null,null)).

